import { world, system, BlockPermutation, Entity } from "@minecraft/server";

world.afterEvents.entityDie.subscribe((data) => {
    const killer = data.damageSource.damagingEntity
    const player = data.deadEntity
    if (player.typeId === ('minecraft:player') && killer.typeId === ('bi:genetic_infiltrator')) {
      const entity = player.dimension.spawnEntity("bi:infected_human", player.location); 		
      entity.nameTag = "" + player.name;
     }
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("infested_core_block:step_on", {
    onStepOn: e => {
      const { block, entity } = e;
      const blockLocation = block.location;
      const randomChance = Math.random();

      if (entity.hasTag('infected')) {
        return;
      }

      if (randomChance <= 0.25) {
        system.run(() => {
          block.dimension.runCommandAsync(`summon bi:genetic_infiltrator ${blockLocation.x + 0.5} ${blockLocation.y + 1} ${blockLocation.z + 0.5}`);
        });
      }
    }
  });
});
